/**
 * Yields iterator which consumes input and yield its values in reverse
 * order. Important: Input MUST be finite.
 *
 * @example
 * ```ts tangle:../export/reverse.ts
 * import { reverse } from "@thi.ng/transducers";
 *
 * console.log(
 *   [...reverse("hello world")]
 * );
 * // [ "d", "l", "r", "o", "w", " ", "o", "l", "l", "e", "h" ]
 * ```
 *
 * @param input -
 */
export declare function reverse<T>(input: Iterable<T>): IterableIterator<T>;
//# sourceMappingURL=reverse.d.ts.map